
############################## Função Vegas #########################################

vegas.t=function(dados,fator, nsim=1000, teste="bi"){
  ## funcao feita na disciplina de Introduçao ao R - marco de 2012  
  ## calcula o p e retorna a matriz de permutaçao para o similar do teste t
  ## deve entrar primeiro o vetor de valores e depois o vetor de fatores
  
  ##cria o vetor de resultados
  resulta<-rep(NA,nsim)
  
  ## coloca o valor da diferenca observada na primeira posicao
  resulta[1]<-diff(tapply(dados,fator,mean)[])
  
  ## ciclos de permutaçao
  for(i in 2:nsim)
    {
      resulta[i]=diff(tapply(sample(dados),fator,mean)[])
      
    }
  
  ##cálculo do nosso p de PATO!!!
  ##é significativa a diferença??
  ## Histograma
  hist(resulta,xlab="Diferenças sob a hipótese nula", main="")
  ## define se o resultado é uni ou bicaudal
  if(teste=="bi")
    {
      ## acrescenta as duas linhas do obervado ao histograma
      abline(v = resulta[1], col="red")
      abline(v = -1*resulta[1], col="red")
      bicaudal=sum(abs(resulta)>=abs(resulta[1]))
      proba=bicaudal/nsim
      ##Mostra resultado na tela
      cat("\n modulo da diferença observado =",abs(resulta[1]),
          "\n\t probabilidade erro tipo I =" , proba, "\n")
    }
  
  if(teste=="uni")
    
    {
      if(resulta[1]<0)
        {
          proba=sum(resulta<=resulta[1])/nsim
        }
      if(resulta[1]>=0)
        {
          proba=sum(resulta>=resulta[1])/nsim
          
        }
      ## Acrescenta apenas uma linha ao histograma
      abline(v = resulta[1], col="red")
      ##Mostra resultado na tela
      cat("\n diferença observada =",resulta[1],
          "\n\t probabilidade erro tipo I =" , proba, "\n")
    }
  return(resulta)
  ##return(list(proba,resulta))
}
  
##########################################################################################################  

